﻿--[[
			oUF_NoMA 

			by	Ballkeep
				modified by Dawn

default features:
* Fallout style!
* player, target, ToT, player pet, focus and focus target frames	
* options to change unit frame sizes (width, height, scale) and position
* changeable color sheme
* clean code ;)
			
added/changed features:
* healthbar on low hp will be colored red (player, pet, party)
* several small tweaks (i.e. mana/health text display for player, player pet and focus frame position, etc.)
* player/target castbar (with cast duration) - incl. option to change position
* party frames
* show 5 man raid as party
* hide party in >5man raids
* oUF_CombatFeedback, SpellRange, Spark, Smooth, BarFader plugin support
* oUF_DebuffHighlight support
* combat and resting icon for player
* PvP flag icon for target
* buff cancel on right click
* matching panels for chatbox and minimap (optional)
* additional name font added
* slightly changed statusbar textures
* gradient colored combo points and hopefully better combo point update function - inspired by oUF_Nerd
* optional fancy glow behind player target ToT, focus, focus target

--]]

-- ------------------------------------------------------------------------
-- Set Up
-- ------------------------------------------------------------------------
local height = {
		["M"] = 28,		--player, target, focus, party
		["S"] = 15, 	--tot, focustarget
		["P"] = 50, 	--pet
		} 

local width = {
		["M"] = 144,	--player, target, focus, party
		["S"] = 122,	--tot, focustarget
		["P"] = 15,		--pet
		}

local Numberzzz = 1
local uiH = 320	--how high ur UF are positioned
local uiW = 250	--how wide ur UF are positioned

-- castbar position (anchor = CENTER)
local playerCastBar_x = 0
local playerCastBar_y = -300
local targetCastBar_x = 0
local targetCastBar_y = 40

-- show/hide minimap and/or chatbox panel and/or buff/topleft panel
local minimappanel = true -- can be true (show)/ false (hide)
local chatpanel = true -- can be true (show)/ false (hide)
local buffpanel = false -- can be true (show)/ false (hide)
local topleftpanel = false -- can be true (show)/ false (hide)

-- show/hide glow on unitframes
local useglow = true

-- ------------------------------------------------------------------------
-- Colors
-- ------------------------------------------------------------------------
--{26/255, 255/255, 139/255}	- deff green
--{255/255, 191/255, 0/255}		- amber
--{173/255, 216/255, 230/255}	- angel blue
--{0/255, 255/255, 255/255}		- cyan
--{255/255, 65/255, 175/255}	- pink xD
--{255/255, 209/255,  71/255} 	- yellow
--{26/255, 200/255, 110/255}	- green (little bit darker)

local m_color = {26/255, 200/255, 110/255}
local r_color = {255/255,70/255,42/255}

local colors = setmetatable({
	--smooth = {r_color[1],r_color[2],r_color[3], r_color[1],r_color[2],r_color[3], r_color[1],r_color[2],r_color[3]},
	smooth = {r_color[1],r_color[2],r_color[3], m_color[1],m_color[2],m_color[3], m_color[1],m_color[2],m_color[3]},	
	health = m_color,
	power = setmetatable({
		['MANA'] = m_color,
		['RAGE'] = m_color,
		['FOCUS'] = m_color,
		['ENERGY'] = m_color,
		['RUNIC_POWER'] = m_color,
	}, {__index = oUF.colors.power}),
--	runes = setmetatable({
--		[1] = {},
--		[2] = {},
--		[3] = {},
--		[4] = {},
--	}, {__index = oUF.colors.runes}),
		happiness = setmetatable({
		[1] = r_color,
		[2] = r_color,
		[3] = m_color,
	}, {__index = oUF.colors.happiness}),
}, {__index = oUF.colors})

-- ------------------------------------------------------------------------
-- Voodoo magic
-- ------------------------------------------------------------------------
local resFolder = "Interface\\AddOns\\Ieo_Res\\"
local texhp1 = resFolder.."status3.tga"
local texmp1 = resFolder.."status4.tga"
local texcast = resFolder.."status3long.tga"

local font = resFolder.."main_font.ttf"
local fontN = resFolder.."name_font.ttf"
local fontSN = 14 -- font size (names)
local fontS = 18 -- font size (numbers)
local fontF = "THINOUTLINE"
local scale = 1
local PartyScale = 0.9
--local fontF = nil

local buffborder = resFolder.."buffborder.tga"

local playerClass = select(2, UnitClass("player"))

-- ------------------------------------------------------------------------
-- Menus
-- ------------------------------------------------------------------------
local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("(.)", string.upper, 1)

	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end

-- ------------------------------------------------------------------------
-- Numbers magic
-- ------------------------------------------------------------------------
function round(num, idp)
  if idp and idp>0 then
    local mult = 10^idp
    return math.floor(num * mult + 0.5) / mult
  end
  return math.floor(num + 0.5)
end

function CoolNumber(num)
	if num>999 then
		return round(num/1e3,Numberzzz).."K"
	else
		return num
	end
end

-- ------------------------------------------------------------------------
-- More voodoo magic
-- ------------------------------------------------------------------------
local updateHealth = function(self, event, unit, bar, min, max)
    local d =(round(min/max, 2)*100)
	if(UnitIsDead(unit)) then
		bar:SetValue(0)
		bar.value:SetText"RIP"		
		bar.PERvalue:SetText("CND 0")
	elseif(UnitIsGhost(unit)) then
		bar:SetValue(0)
		bar.value:SetText"GHO"		
		bar.PERvalue:SetText("CND 0")
	elseif(not UnitIsConnected(unit)) then
		bar.value:SetText"OFF"	
		bar.PERvalue:SetText("CND 0")
	elseif(unit == "player") then
		if(d < 35) then
			bar.PERvalue:SetText("CND"..(round(min/max, 2)*100))		
			bar.value:SetText(CoolNumber(min))
		else
			bar.PERvalue:SetText(" ")
			bar.value:SetText(CoolNumber(min))
		end	
	elseif(unit == "target")or(unit == "focus") then
		bar.PERvalue:SetText("CND"..(round(min/max, 2)*100))
		bar.value:SetText(CoolNumber(min))
	else
		bar.value:SetText(CoolNumber(min))	
	end
	
	bar.value:SetTextColor(m_color[1],m_color[2],m_color[3])
	bar.PERvalue:SetTextColor(m_color[1],m_color[2],m_color[3])
end

local updatePower = function(self, event, unit, bar, min, max)
	if(min == 0 or max == 0 or not UnitIsConnected(unit)) then
		bar.value:SetText()
		bar:SetValue(0)
	elseif(UnitIsDead(unit) or UnitIsGhost(unit)) then
		bar:SetValue(0)
	elseif(unit == "player") then
		--bar.value:SetText(min.."/"..CoolNumber(max))
		bar.value:SetText(CoolNumber(min).."/")
	elseif(unit == "target")or(unit == "focus") then
		bar.value:SetText(CoolNumber(min).."/")
	else
		bar.value:SetText(min.."/"..CoolNumber(max))
	end
	
	bar.value:SetTextColor(m_color[1],m_color[2],m_color[3])
end

-- ------------------------------------
-- aura cancel on right click
-- ------------------------------------		
local function onMouseUp(self, button)
	if(button == 'RightButton') then
		CancelUnitBuff(self.frame.unit, self:GetID(), self.filter)
	end
end

-- ------------------------------------
-- Combo Point update function
-- ------------------------------------		
local function updateCPoints(self, event, unit)
	if unit == PlayerFrame.unit then
		local cp = GetComboPoints(unit, "target")
		--local r, g, b = 1, 1, 1
		if cp ~= 0 then
			local r, g, b = oUF.ColorGradient(cp * .15, unpack(oUF.colors.smooth))
			self.CPoints:SetTextColor(r, g, b)
		end
		self.CPoints.unit = unit
	end
end	

-- ------------------------------------------------------------------------
-- Skinning buffs
-- ------------------------------------------------------------------------
local function PostCreateAuraIcon(self, button, icons, index, debuff)
	icons.showDebuffType = true -- show debuff border type color  
	
	button.icon:SetTexCoord(.07, .93, .07, .93)
	button.icon:SetPoint("TOPLEFT", button, "TOPLEFT", 1, -1)
	button.icon:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -1, 1)

    button.count:SetPoint("TOPRIGHT", button, 4, 22)
    button.count:SetTextColor(0.9,0.9,0.9)
	button.count:SetFont(font, fontS-4, fontF)
	
	button.overlay:SetTexture(buffborder)
	button.overlay:SetTexCoord(0,1,0,1)
	button.overlay.Hide = function(self) self:SetVertexColor(0.3, 0.3, 0.3) end

	button.cd:SetPoint("BOTTOM", button, 0, -19) 	
	button.cd:SetReverse()
	
	button:SetScript('OnMouseUp', onMouseUp)   	
end

-- ------------------------------------------------------------------------
-- custom castbar text
-- ------------------------------------------------------------------------

local function CustomTimeText(self, duration)
	if self.casting then
		self.Time:SetFormattedText('%.1f / ', (self.max - duration))
		self.Time2:SetFormattedText('%.1f', self.max)
	elseif self.channeling then
		self.Time:SetFormattedText('%.1f / ', duration)
		self.Time2:SetFormattedText('%.1f', self.max)
	end
end
  
-- ------------------------------------------------------------------------
-- Style
-- ------------------------------------------------------------------------
local function Style(self, unit)

	-- hide blizzard rune frame
	RuneFrame:Hide()

	-- ------------------------------------------------------------------------
	-- Menu & register events
	-- ------------------------------------------------------------------------
	self.menu = menu
	
	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)
	
	self:RegisterForClicks("anyup")
	self:SetAttribute("*type2", "menu")
	
	-- ------------------------------------------------------------------------
	-- Health bar
	-- ------------------------------------------------------------------------
	self.Health = CreateFrame("StatusBar")
	self.Health:SetStatusBarTexture(texhp1)
	self.Health:SetParent(self)
	self.Health:SetHeight(18)

	self.Health.bg = self.Health:CreateTexture(nil, "BORDER")
	self.Health.bg:SetAllPoints(self.Health)
	self.Health.bg:SetTexture(texhp1)
	self.Health.bg:SetAlpha(0.30)
	
	self.Health:SetPoint("TOPLEFT", self, "TOPLEFT")
	self.Health:SetPoint("TOPRIGHT", self, "TOPRIGHT")

	self.Health.frequentUpdates = true
	self.Health.colorHealth = true
	self.Health.colorHappiness = true
	self.Health.colorDisconnected = true
	self.Health.colorTapping = true	
	
	-- ------------------------------------------------------------------------
	-- Power bar
	-- ------------------------------------------------------------------------
	self.Power = CreateFrame("StatusBar")
	self.Power:SetStatusBarTexture(texmp1)
	self.Power:SetHeight(3)

	self.Power:SetParent(self)
	self.Power:SetPoint("BOTTOMLEFT", self, "BOTTOMLEFT")
	self.Power:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT")

	self.Power.frequentUpdates = true
	self.Power.colorPower = true
	self.Power.colorTapping = true

	-- ------------------------------------------------------------------------
	-- Text fields |cff00DBBA
	-- ------------------------------------------------------------------------
	self.Health.value = self.Health:CreateFontString(nil, "OVERLAY")
	self.Health.value:SetFont(font, fontS+8, fontF)
	
	self.Health.PERvalue = self.Health:CreateFontString(nil, "OVERLAY")
	self.Health.PERvalue:SetFont(font, fontS, fontF)

	self.Power.value = self.Power:CreateFontString(nil, "OVERLAY")
	self.Power.value:SetFont(font, fontS, fontF)
	
	self.Name = self.Health:CreateFontString(nil, "OVERLAY")
	self.Name:SetJustifyH("CENTER")
	self.Name:SetFont(fontN, fontSN, fontF)
	self:Tag(self.Name, '[raidcolor][name]')

	-- ------------------------------------
	-- Combat Feedback for all frames
	-- ------------------------------------			
	local cbft = self.Health:CreateFontString(nil, "OVERLAY")
		cbft:SetPoint("CENTER", self.Health, "CENTER", 0, 0)
		cbft:SetFontObject(GameFontNormal)
		self.CombatFeedbackText = cbft	
		self.CombatFeedbackText:SetFont(font, 16, "OUTLINE")	

	-- ------------------------------------	
	-- oUF_SpellRange fading and oUF_Smooth support for all frames
	-- ------------------------------------	
	if(unit) or (self:GetParent():GetName():match"oUF_Party") then 
		self.SpellRange = true; -- fadeout if units are out of range
		self.inRangeAlpha = 1.0; -- Frame alpha when in range
		self.outsideRangeAlpha = 0.3; -- Frame alpha when out of range
		self.Power.Smooth = true
		self.Health.Smooth = true
	end

	-- ------------------------------------
	-- health color gradient for player, party, raid, pet
	-- ------------------------------------	
	if unit=="player" or unit=="pet" or (self:GetParent():GetName():match"oUF_Party") then	
		self.Health.colorSmooth = true		
	end

	-- ------------------------------------------------------------------------
	-- Raid icons
	-- ------------------------------------------------------------------------
	self.RaidIcon = self.Health:CreateTexture(nil, "OVERLAY")
	self.RaidIcon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
	self.RaidIcon:SetHeight(20)
	self.RaidIcon:SetWidth(20)
		
	-- ------------------------------------------------------------------------
	-- Auras system
	-- ------------------------------------------------------------------------
	self.Buffs = CreateFrame("Frame", nil, self)
	self.Buffs.initialAnchor = "TOPLEFT"
	self.Buffs["growth-y"] = "DOWN"
	self.Buffs:SetHeight(220)
	self.Buffs:SetWidth(180)
	self.Buffs.size = 21
	self.Buffs.spacing = 1
	
	self.Debuffs = CreateFrame("Frame", nil, self)
	self.Debuffs.initialAnchor = "BOTTOMLEFT"
	self.Debuffs["growth-y"] = "UP"
	self.Debuffs:SetHeight(75)
	self.Debuffs:SetWidth(180)
	self.Debuffs.size = 35
	self.Debuffs.spacing = 1
	--self.Debuffs.onlyShowPlayer = 1

	-- ------------------------------------
	-- oUF_DebuffHighlight support - border highlight
	-- ------------------------------------
	if unit=="player" or unit=="target" or unit=="pet" or (self:GetParent():GetName():match"oUF_Party") then
		self.DebuffHighlight = self:CreateTexture(nil, "OVERLAY")
		self.DebuffHighlight:SetPoint("TOPLEFT",self.Health,"TOPLEFT",-3,3)
		self.DebuffHighlight:SetPoint("BOTTOMRIGHT",self.Health,"BOTTOMRIGHT",3,-3)
		self.DebuffHighlight:SetTexture(resFolder.."status1.tga")
		self.DebuffHighlight:SetVertexColor(0, 0, 0, 0)
		self.DebuffHighlight:SetBlendMode("ADD")
		self.DebuffHighlightAlpha = 0.8
		self.DebuffHighlightFilter = true
	end

-- ------------------------------------------------------------------------
-- Individual frames setup
-- ------------------------------------------------------------------------
	
	-- ------------------------------------
	-- player and target castbar
	-- ------------------------------------	
	if(unit == 'player' or unit == 'target') then
	    self.Castbar = CreateFrame('StatusBar', nil, self)
	    self.Castbar:SetStatusBarTexture(texcast)
		self.Castbar:SetFrameStrata("LOW")
		self.Castbar:SetFrameLevel(3)

		self.Castbar.bg = self.Castbar:CreateTexture(nil, "BORDER")
		self.Castbar.bg:SetAllPoints(self.Castbar)
		self.Castbar.bg:SetTexture(texcast)
		self.Castbar.bg:SetAlpha(0.30)  

		self.Castbar.bg2 = self.Castbar:CreateTexture(nil, "BACKGROUND")
		self.Castbar.bg2:SetPoint("TOPLEFT",self.Castbar,"TOPLEFT",-1,1)
		self.Castbar.bg2:SetPoint("BOTTOMRIGHT",self.Castbar,"BOTTOMRIGHT",1,-1)	
		self.Castbar.bg2:SetTexture(texcast)
		self.Castbar.bg2:SetVertexColor(0, 0, 0, 0.4)
		
		self.Castbar.Text = self.Castbar:CreateFontString(nil, 'OVERLAY')
	    self.Castbar.Text:SetPoint('LEFT', self.Castbar, 0, 18)
	    self.Castbar.Text:SetFont(font, fontSN, fontF)
		self.Castbar.Text:SetShadowOffset(1, -1)
	    self.Castbar.Text:SetTextColor(1, 1, 1)
	    self.Castbar.Text:SetJustifyH('LEFT')

		self.Castbar.Time = self.Castbar:CreateFontString(nil, 'OVERLAY')
		self.Castbar.Time:SetPoint('RIGHT', self.Castbar, -22, 18)
		self.Castbar.Time:SetFont(font, fontS-2, fontF)
		self.Castbar.Time:SetTextColor(1, 1, 1)
		self.Castbar.Time:SetJustifyH('RIGHT')

		self.Castbar.Time2 = self.Castbar:CreateFontString(nil, 'OVERLAY')
		self.Castbar.Time2:SetPoint('RIGHT', self.Castbar.Time, 23, -3)
		self.Castbar.Time2:SetFont(font, fontS+6, fontF)
		self.Castbar.Time2:SetTextColor(1, 1, 1)
		self.Castbar.Time2:SetJustifyH('RIGHT')

		self.Castbar.CustomTimeText = CustomTimeText
		
		--[[ spell icon
		self.Castbar.Icon = self.Castbar:CreateTexture(nil, 'ARTWORK')
		self.Castbar.Icon:SetHeight(16)
		self.Castbar.Icon:SetWidth(16)
		self.Castbar.Icon:SetTexCoord(0.1,0.9,0.1,0.9)
		self.Castbar.Icon:SetPoint('LEFT', -18, 0)
		--]]
		
		if(unit == "player") then
			self.Castbar:SetStatusBarColor(m_color[1],m_color[2],m_color[3]) -- healthbar colored player castbar
			--self.Castbar:SetStatusBarColor(1.00, 1.00, 0.39) -- custom colored player castbar
			self.Castbar:SetHeight(16)
			self.Castbar:SetWidth(300)
			self.Castbar:SetAlpha(0.90)
			
			self.Castbar.SafeZone = self.Castbar:CreateTexture(nil,"ARTWORK")
			self.Castbar.SafeZone:SetTexture(texcast)
			self.Castbar.SafeZone:SetVertexColor(0.85,0.10,0.10,0.90)
			self.Castbar.SafeZone:SetPoint("TOPRIGHT")
			self.Castbar.SafeZone:SetPoint("BOTTOMRIGHT")
			
			self.Castbar:SetPoint('CENTER', UIParent, 'CENTER', playerCastBar_x, playerCastBar_y)

		else
			--self.Castbar:SetStatusBarColor(m_color[1],m_color[2],m_color[3]) -- bar colored target castbar		
			self.Castbar:SetStatusBarColor(0.85, 0, 0) -- custom colored target castbar
			self.Castbar:SetHeight(16)
			self.Castbar:SetWidth(300)
			
			self.Castbar:SetPoint('CENTER', UIParent, 'CENTER', targetCastBar_x, targetCastBar_y)
		end
	end

	-- ------------------------------------------------------------------------
	-- Player
	-- ------------------------------------------------------------------------
	if unit == "player" then
		local a = CreateFrame("Frame", nil, self)
		a:SetFrameStrata("BACKGROUND")
		a:SetFrameLevel(0)
		a:SetWidth(256)
		a:SetHeight(128)
		a:SetPoint("CENTER", self, "CENTER", 7, -7)
		a:Show()
		a.texture = a:CreateTexture(nil)
		a.texture:SetAllPoints(a)
		a.texture:SetTexture(resFolder.."bg1.tga")
		a.texture:SetVertexColor(m_color[1],m_color[2],m_color[3])
		
		self.BarFade = true
		self.BarFadeMinAlpha = 0.2
		cbft:SetPoint("RIGHT", self.Health, 44, 0)
		
		self.Health.value:SetPoint("BOTTOMLEFT", self.Health, "TOPLEFT", 2, 0)
		self.Power.value:SetPoint("TOPRIGHT", self.Health.value, "TOPLEFT", 2, 0)
		self.Health.PERvalue:SetPoint("TOPLEFT", self.Health.value, "TOPRIGHT")

		--
		-- oUF_PowerSpark support
		--
		self.Spark = self.Power:CreateTexture(nil, "OVERLAY")
		self.Spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		self.Spark:SetVertexColor(1, 1, 1, 1)
		self.Spark:SetBlendMode("ADD")
		self.Spark:SetHeight(self.Power:GetHeight()*12)
		self.Spark:SetWidth(5)	
		
		self.Combat = self.Health:CreateTexture(nil, 'OVERLAY')
		self.Combat:SetHeight(14)
		self.Combat:SetWidth(14)
		self.Combat:SetPoint("LEFT", self.Health, -20, 12)	
		self.Combat:SetTexture(resFolder.."raid\\combat.tga")	
		self.Combat:SetVertexColor(m_color[1],m_color[2],m_color[3])
		
		self.Resting = self.Health:CreateTexture(nil, 'OVERLAY')
		self.Resting:SetHeight(14)
		self.Resting:SetWidth(14)
		self.Resting:SetPoint('CENTER', self.Combat, 0, -16)
		self.Resting:SetTexture(resFolder.."raid\\rest.tga")		
		self.Resting:SetVertexColor(m_color[1],m_color[2],m_color[3])
		
		self.Leader = self.Health:CreateTexture(nil, "OVERLAY")
		self.Leader:SetHeight(14)
		self.Leader:SetWidth(14)
		self.Leader:SetPoint('CENTER', self.Resting, 0, -16)
		self.Leader:SetTexture(resFolder.."raid\\leader.tga")
		self.Leader:SetVertexColor(m_color[1],m_color[2],m_color[3])
	
		self.MasterLooter = self.Health:CreateTexture(nil, 'OVERLAY')
		self.MasterLooter:SetHeight(14)
		self.MasterLooter:SetWidth(14)
		self.MasterLooter:SetPoint('CENTER', self.Leader, 0, -16)
		self.MasterLooter:SetTexture(resFolder.."raid\\looter.tga")		
		self.MasterLooter:SetVertexColor(m_color[1],m_color[2],m_color[3])
		
		self:SetAttribute("initial-height", height.M)
		self:SetAttribute("initial-width", width.M)
	end
	
	-- ------------------------------------------------------------------------
	-- Target, Focus
	-- ------------------------------------------------------------------------
    if(unit == "target")or(unit == "focus") then
		local a = CreateFrame("Frame", nil, self)
		a:SetFrameStrata("BACKGROUND")
		a:SetFrameLevel(0)
		a:SetWidth(256)
		a:SetHeight(128)
		a:SetPoint("CENTER", self, "CENTER", -10, -9)
		a:Show()
		a.texture = a:CreateTexture(nil)
		a.texture:SetAllPoints(a)
		a.texture:SetTexture(resFolder.."bg2.tga")
		a.texture:SetVertexColor(m_color[1],m_color[2],m_color[3])

		self.Health.value:SetPoint("BOTTOMRIGHT", self.Health, "TOPRIGHT")
		self.Power.value:SetPoint("TOPRIGHT", self.Health.value, "TOPLEFT")
		
		self.Health.PERvalue:SetPoint("RIGHT", self.Power, "LEFT", -10, 0)
		
		self.Power:ClearAllPoints()
		self.Power:SetPoint("BOTTOM", self, "BOTTOM", 0, -14)
		self.Power:SetPoint("RIGHT", self, "RIGHT")
		self.Power:SetHeight(15)
		self.Power:SetWidth(71)
		
		self.Name:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 27)
	
		self.Buffs:SetPoint("TOPLEFT", self, "BOTTOMLEFT", -27, -30)
		self.Debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -27, 42)

		self.RaidIcon:SetPoint("RIGHT", self.Health, 26, 12)	
		
		if ((playerClass == "ROGUE")or(playerClass == "DRUID"))and(unit == "target") then
		local cp = self:CreateFontString(nil, "ARTWORK")
		cp:SetFont(font, fontS+42, fontF)
		cp:SetTextColor(m_color[1],m_color[2],m_color[3])
		cp:SetPoint("RIGHT", self, "LEFT", -50, 0)
		cp:SetJustifyH("RIGHT")
		
		self.CPoints = cp
		self:RegisterEvent("UNIT_COMBO_POINTS", updateCPoints)
		end	

		self:SetAttribute("initial-height", height.M)
		self:SetAttribute("initial-width", width.M)
    end

	if(unit == "target") then
		self.Buffs:ClearAllPoints()	
		self.Buffs:SetPoint("RIGHT", self, 48, -18)		
		self.Buffs.initialAnchor = "RIGHT"
		self.Buffs["growth-y"] = "UP"
		self.Debuffs.filter = "HARMFUL|PLAYER"		
		cbft:SetPoint("LEFT", self.Health, -44, 0)	
		
		-- PvP Icon
		local pvp = self.Health:CreateTexture(nil, "OVERLAY")	
		pvp:ClearAllPoints()
		pvp:SetPoint('CENTER', self.RaidIcon, 0, -22)
		pvp:SetHeight(20)
		pvp:SetWidth(20)
		--pvp:SetVertexColor(m_color[1],m_color[2],m_color[3])
		self.PvP = pvp
	end		
	-- ------------------------------------------------------------------------
	-- ToT, FoT
	-- ------------------------------------------------------------------------
	if(unit == "targettarget")or(unit == "focustarget") then
		local a = CreateFrame("Frame", nil, self)
		a:SetFrameStrata("BACKGROUND")
		a:SetFrameLevel(0)
		a:SetWidth(256)
		a:SetHeight(32)
		a:SetPoint("CENTER", self, "CENTER", 1, -7)
		a:Show()
		a.texture = a:CreateTexture(nil)
		a.texture:SetAllPoints(a)
		a.texture:SetTexture(resFolder.."bg3.tga")
		a.texture:SetVertexColor(255/255, 70/255, 42/255)

		self.Health:ClearAllPoints()
		self.Health:SetAllPoints(self)
		self.Health.colorSmooth = true
		self.Power:Hide()

		self.Name:SetPoint("BOTTOM", self, "TOP", 0, 0)
		
		self.Buffs:SetHeight(20)
		self.Buffs:SetWidth(160)
		self.Buffs.size = 19
		self.Buffs.num = 8
		self.Buffs:SetPoint("TOPLEFT", self, "BOTTOMLEFT", -20, -5)
		self.Buffs.filter = "HELPFUL|RAID"
		
		self:SetAttribute("initial-height", height.S)
		self:SetAttribute("initial-width", width.S)
	end
	
	
	-- ------------------------------------------------------------------------
	-- Pet
	-- ------------------------------------------------------------------------
    if (unit == "pet") then
		self.Health:ClearAllPoints()
		self.Health:SetStatusBarTexture(texmp1)
		self.Health:SetAllPoints(self)
		self.Health:SetOrientation("VERTICAL")

		self.BarFade = true
		self.BarFadeMinAlpha = 0.2		
		self.Power:Hide()
	
        self:SetAttribute("initial-height", height.P)
		self:SetAttribute("initial-width", width.P)
	end

	-- ------------------------------------------------------------------------
	-- Party
	-- ------------------------------------------------------------------------
	if(self:GetParent():GetName():match"oUF_Party") then
		local a = CreateFrame("Frame", nil, self)
		a:SetFrameStrata("BACKGROUND")
		a:SetFrameLevel(0)
		a:SetWidth(256)
		a:SetHeight(128)
		a:SetPoint("CENTER", self, "CENTER", 7, -7)
		a:Show()
		a.texture = a:CreateTexture(nil)
		a.texture:SetAllPoints(a)
		a.texture:SetTexture(resFolder.."bg1.tga")
		a.texture:SetVertexColor(m_color[1],m_color[2],m_color[3])
	
		cbft:SetPoint("RIGHT", self.Health, 40, 0)
		
		self.Health.value:SetPoint("BOTTOMLEFT", self.Health, "TOPLEFT", -2, 0)
		self.Power.value:SetPoint("TOPLEFT", self.Power, "BOTTOMLEFT", -2, 0)
		
		self.Buffs:SetPoint("TOPLEFT", self, "BOTTOMLEFT", -7, -30)
		self.Debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -7, 30)
		self.Debuffs.size = 22		
		self.Buffs.num = 8
		self.Debuffs.num = 8
		self.Buffs.filter = "HELPFUL|RAID"
		
	self.Leader = self.Health:CreateTexture(nil, "OVERLAY")
	self.Leader:SetHeight(14)
	self.Leader:SetWidth(14)
	self.Leader:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, -7)
	self.Leader:SetTexture(resFolder.."raid\\leader.tga")
	self.Leader:SetVertexColor(m_color[1],m_color[2],m_color[3])
		
	self.MasterLooter = self.Health:CreateTexture(nil, 'OVERLAY')
	self.MasterLooter:SetHeight(14)
	self.MasterLooter:SetWidth(14)
	self.MasterLooter:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 15, -7)
	self.MasterLooter:SetTexture(resFolder.."raid\\looter.tga")
	self.MasterLooter:SetVertexColor(m_color[1],m_color[2],m_color[3])	
	
	self.RaidIcon = self.Health:CreateTexture(nil, "OVERLAY")
    self.RaidIcon:SetHeight(13)
    self.RaidIcon:SetWidth(13)
    self.RaidIcon:SetPoint("TOP", self, 0, 6)
    self.RaidIcon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
		
		self:SetAttribute("initial-height", height.M)
		self:SetAttribute("initial-width", width.M)
	end

	-- ------------------------------------------------------------------------
	-- Hello local functions
	-- ------------------------------------------------------------------------
	self.colors = colors
	self.PostUpdateHealth = updateHealth
	self.PostUpdatePower = updatePower
	self.PostCreateAuraIcon = PostCreateAuraIcon
	return self   
end

-- ------------------------------------------------------------------------
-- Register our layout
-- ------------------------------------------------------------------------
oUF:RegisterStyle("oUF_NoMA", Style)
oUF:SetActiveStyle("oUF_NoMA")

-- ------------------------------------------------------------------------
-- Spawning frames
-- ------------------------------------------------------------------------
oUF:Spawn("player", "oUF_Player"):SetPoint("BOTTOM", UIParent, "BOTTOM", uiW*(-1), uiH)
oUF:Spawn("pet", "oUF_Pet"):SetPoint("BOTTOMLEFT", oUF.units.player, -30, -20)

oUF:Spawn("target", "oUF_Target"):SetPoint("BOTTOM", UIParent, "BOTTOM", uiW, uiH)
oUF:Spawn("focus", "oUF_Focus"):SetPoint("BOTTOM", UIParent, "BOTTOM", -uiW*1.8, uiH)

oUF:Spawn("targettarget", "oUF_TargetTarget"):SetPoint("BOTTOM", UIParent, "BOTTOM", 0, uiH+7)
oUF:Spawn("focustarget", "oUF_FocusTarget"):SetPoint("BOTTOM", UIParent, "BOTTOM", 0, uiH+60)

-- party
local party = oUF:Spawn("header", "oUF_Party")
party:SetManyAttributes("showParty", true, "xOffset", 60, "point", "LEFT")
party:SetPoint("BOTTOM", UIParent, "BOTTOM", uiW*(-1)+250, uiH-100)
party:Show()

oUF_Party:SetScale(PartyScale)

oUF_Player:SetScale(scale)
oUF_Pet:SetScale(scale)
oUF_Target:SetScale(scale)
oUF_Focus:SetScale(scale)
oUF_TargetTarget:SetScale(scale)
oUF_FocusTarget:SetScale(scale)

--
-- party toggle in raid
--
local partyToggle = CreateFrame('Frame')
partyToggle:RegisterEvent('PLAYER_LOGIN')
partyToggle:RegisterEvent('RAID_ROSTER_UPDATE')
partyToggle:RegisterEvent('PARTY_LEADER_CHANGED')
partyToggle:RegisterEvent('PARTY_MEMBERS_CHANGED')
partyToggle:SetScript('OnEvent', function(self)
	if(InCombatLockdown()) then
		self:RegisterEvent('PLAYER_REGEN_ENABLED')
	else
		self:UnregisterEvent('PLAYER_REGEN_ENABLED')
		if(GetNumRaidMembers() > 5) then
			party:Hide()
		else
			party:Show()
		end
	end
end)

-- ------------------------------------------------------------------------
-- background frames
-- ------------------------------------------------------------------------
if minimappanel == true then 
	local mappanel = CreateFrame("Frame",nil,Minimap)
	mappanel:SetParent(Minimap)
	mappanel:ClearAllPoints()	
	mappanel:SetFrameStrata("BACKGROUND")
	mappanel:SetWidth(256)
	mappanel:SetHeight(256)
	mappanel:SetPoint("CENTER",Minimap,0,0)
	mappanel:SetFrameLevel(2)	
	mappanel:Show()
	mappanel:SetScale(1)
	local mappanel1 = mappanel:CreateTexture(nil,"BACKGROUND")
	mappanel1:SetTexture(resFolder.."art\\minibox.tga")
	mappanel1:SetAllPoints(mappanel)
	mappanel1:SetVertexColor(m_color[1],m_color[2],m_color[3])
	mappanel1:SetAlpha(1)
end

if chatpanel == true then 	
	local chatbox = CreateFrame("Frame",nil,UIParent)
	chatbox:SetFrameStrata("BACKGROUND")
	chatbox:SetWidth(512)
	chatbox:SetHeight(256)
	chatbox:SetPoint("BOTTOMLEFT", -2, 0)
	chatbox:Show()
	chatbox:SetScale(0.8)
	local chatbox2 = chatbox:CreateTexture(nil,"BACKGROUND")
	chatbox2:SetTexture(resFolder.."art\\chatbox.tga")
	chatbox2:SetAllPoints(chatbox)	
	chatbox2:SetVertexColor(m_color[1],m_color[2],m_color[3])
	chatbox2:SetAlpha(1)
end	

if buffpanel == true then 	
	local buffbox = CreateFrame("Frame",nil,UIParent)
	buffbox:SetFrameStrata("BACKGROUND")
	buffbox:SetWidth(512)
	buffbox:SetHeight(256)
	buffbox:SetPoint("TOPRIGHT", 0, 0)
	buffbox:Show()
	buffbox:SetScale(0.8)
	local buffbox2 = buffbox:CreateTexture(nil,"BACKGROUND")
	buffbox2:SetTexture(resFolder.."art\\buffbox.tga")
	buffbox2:SetAllPoints(buffbox)	
	buffbox2:SetVertexColor(m_color[1],m_color[2],m_color[3])
	buffbox2:SetAlpha(0.6)
end	

if topleftpanel == true then 	
	local boxtopleft = CreateFrame("Frame",nil,UIParent)
	boxtopleft:SetFrameStrata("BACKGROUND")
	boxtopleft:SetWidth(512)
	boxtopleft:SetHeight(256)
	boxtopleft:SetPoint("TOPLEFT", 0, 0)
	boxtopleft:Show()
	boxtopleft:SetScale(0.8)
	local boxtopleft2 = boxtopleft:CreateTexture(nil,"BACKGROUND")
	boxtopleft2:SetTexture(resFolder.."art\\boxtopleft.tga")
	boxtopleft2:SetAllPoints(boxtopleft)	
	boxtopleft2:SetVertexColor(m_color[1],m_color[2],m_color[3])
	boxtopleft2:SetAlpha(0.6)
end	

-- ------------------------------------------------------------------------
-- glow animation 
-- GreenRadiationFog.m2 BlackRadiationFog.m2 WhiteRadiationFog.m2
-- RedRadiationFog.m2 RedRadiationFog.m2 OrangeRadiationFog.m2
-- ------------------------------------------------------------------------
if useglow == true then 
local color = 'SPELLS\\WhiteRadiationFog.m2'

local fogframes, frames = {}, {
	oUF_Player = {-100,4,50,9},
	oUF_Target = {-120,4,50,9},
	oUF_TargetTarget = {-120,4,50,0},
	oUF_FocusTarget = {-120,4,50,0},	
	oUF_Focus = {-120,4,50,9},	
}

for frame, position in pairs(frames) do
	if getglobal(frame) then
		local f = CreateFrame'PlayerModel'
		f:SetParent(frame)
		f:SetFrameStrata'BACKGROUND'
		if type(position) == 'table' then
			f:SetPoint('TOPLEFT', frame, position[1], position[2])
			f:SetPoint('BOTTOMRIGHT', frame, position[3], position[4])
		else
			f:SetAllPoints(frame)
		end
		f:SetScript('OnShow', function(self) self:SetModel(color) end)
		f:SetModel(color)
		f:SetModelScale(0.7)
		--f:SetPosition(-12,0.1,-1.1) 
		f:SetPosition(-12,0.5,-0.8) 
		f:SetAlpha(0.7)
		f:Show()
		table.insert(fogframes,f)
	end
end

local function Hook(frame, script, func)
	if frame:GetScript(script) then
		frame:HookScript(script, func)
	else
		frame:SetScript(script, func)
	end
end

Hook(WorldMapFrame, 'OnHide', function()
	for i = 1, #fogframes do
		local f = fogframes[i]
		f:SetModel(color)
		f:Show()
	end
end)
end